#include <stdint.h>
#ifndef __VARIABLE_H
#define __VARIABLE_H

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    uint8_t mMilSecCount;           // 毫秒计数
    uint8_t bTenMilSecOk;           // 10毫秒标志位
    uint8_t mTimeCount;             // 秒计数
    uint8_t bTimeOk;                // 秒标志位
    uint8_t mHundredMilSecCount;    // 百微秒计数
    uint8_t bHundredMilSecOk;       // 百微秒标志位
} stSysTickTimer;

typedef struct {
  uint8_t mSecond;
  uint8_t mMinute;
  uint8_t mHour;
  uint8_t mTimeCount;
  uint8_t bSecondIsOk;
  uint8_t mTenMilCount;
  uint8_t bTenMilIsOk;
} structTime;

typedef enum {
    SET_HOUR_TENS,    // 小时十位
    SET_HOUR_ONES,    // 小时个位
    SET_MIN_TENS,     // 分钟十位
    SET_MIN_ONES,     // 分钟个位
    SET_SEC_TENS,     // 秒十位
    SET_SEC_ONES,     // 秒个位
    SET_DONE          // 设置完成
} TIME_STATE;

#ifdef __cplusplus
}
#endif

#endif /* __VARIABLE_H */
