/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2025 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "spi.h"
#include "tim.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "variable.h"
#include "lcd.h"
#include "test.h"
#include "SegLed.h"
#include "MatrixKey.h"
#include "gui.h"
#include <stdio.h>
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
uint16_t mPos=0;

uint16_t mNum=15;

stSysTickTimer sSysTickTimer = {
  0, 0, 0, 0
};
uint8_t tempValue = 255;
structTime stTime = {
  .mSecond = 50,
  .mMinute = 45,
  .mHour = 8,
  .mTimeCount = 0,
  .bSecondIsOk = 0,
  .mTenMilCount = 0,
  .bTenMilIsOk = 0
};
uint8_t KeyValue = 0;

extern uint8_t is_setting_time;
extern TIME_STATE set_time_state;
extern uint32_t blink_counter;
extern uint8_t show_digit;

enum picture_index {
  NEURO_SAMA_SMALL,
  EVIL_NEURO_SMALL
} pic_index = 0;

extern const unsigned char gImage_qq[3200];
extern const unsigned char gImage_Neuro_Sama[40704];
extern const unsigned char gImage_Neuro_Sama_small[10112];
extern const unsigned char gImage_Evil_Neuro_small[10240];
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void Gui_Drawbmp_full(uint16_t x, uint16_t y, uint16_t width, uint16_t height, const unsigned char *p)
{
  int i;
	unsigned char picH,picL;
	LCD_SetWindows(x,y,x+width-1,y+height-1);
  for(i=0;i<width*height;i++)
	{	
	 	picL=*(p+i*2);
		picH=*(p+i*2+1);				
		Lcd_WriteData_16Bit(picH<<8|picL);  						
	}	
	LCD_SetWindows(0,0,lcddev.width-1,lcddev.height-1);
}
void my_init(void) {
	LCD_direction(1);
	Gui_Drawbmp_full(0,0,159,128,gImage_Neuro_Sama);
	HAL_Delay(1200);
  LCD_Clear(WHITE);
}
void refresh_picture() {
  switch (pic_index) {
    case NEURO_SAMA_SMALL:
      Gui_Drawbmp_full(40,50,79,64,gImage_Neuro_Sama_small);
      break;
    case EVIL_NEURO_SMALL:
      Gui_Drawbmp_full(40,50,80,64,gImage_Evil_Neuro_small);
      break;
    default:
      break;
  }
  pic_index = (pic_index + 1) % 2;
}
void my_show_time(void) {
    char timeStr[20];
    sprintf(timeStr, "%02d:%02d:%02d", stTime.mHour, stTime.mMinute, stTime.mSecond);
    
    if (is_setting_time && show_digit) {
        // 在设置模式下，根据当前设置的位置显示闪烁
        char mask[6] = {':', ':', '\0'};  // 用于保持冒号显示
        switch (set_time_state) {
            case SET_HOUR_TENS:  timeStr[0] = ' '; break;
            case SET_HOUR_ONES:  timeStr[1] = ' '; break;
            case SET_MIN_TENS:   timeStr[3] = ' '; break;
            case SET_MIN_ONES:   timeStr[4] = ' '; break;
            case SET_SEC_TENS:   timeStr[6] = ' '; break;
            case SET_SEC_ONES:   timeStr[7] = ' '; break;
            case SET_DONE:                         break;
        }
    }
    
    Show_Str(50, 10, BLUE, YELLOW, timeStr, 16, 0);
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_SPI2_Init();
  MX_TIM3_Init();
  /* USER CODE BEGIN 2 */
  HAL_TIM_Base_Start_IT(&htim3);
  TimeToBuff(&stTime);
  LCD_Init();
  my_init();
  refresh_picture();
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
    if (sSysTickTimer.bTenMilSecOk) {
      sSysTickTimer.bTenMilSecOk = 0;
    }
    if (stTime.bSecondIsOk) {
      stTime.bSecondIsOk = 0;
    }
    // main_test();
    // Test_Color();
    // Test_FillRec();
    // Test_Circle();
    // Test_Triangle();
    // English_Font_test();
    // Chinese_Font_test();
    // Pic_test();
    // Rotate_Test();
    if (sSysTickTimer.bHundredMilSecOk) {
      sSysTickTimer.bHundredMilSecOk = 0;
      my_show_time();
    }
    if (sSysTickTimer.bTimeOk) {
      sSysTickTimer.bTimeOk = 0;
      HAL_GPIO_TogglePin(TickLed_GPIO_Port, TickLed_Pin);
    }
    if (tempValue == 10) {
      refresh_picture();
      tempValue = 255;
    } 
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1_BOOST);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = RCC_PLLM_DIV6;
  RCC_OscInitStruct.PLL.PLLN = 85;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
