/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    stm32g4xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2025 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32g4xx_it.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "variable.h"
#include "hc595.h"
#include "SegLed.h"
#include "MatrixKey.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */

/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */

TIME_STATE set_time_state = SET_DONE;

uint8_t is_setting_time = 0;    // 是否在设置时间模式
uint32_t blink_counter = 0;     // 用于闪烁效果的计数器
uint8_t show_digit = 1;         // 用于闪烁效果

extern uint8_t tempValue;
extern structTime stTime;
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

void process_time_setting() {
    if (tempValue == 11) {  // 按键11用于进入/退出设置模式
        if (!is_setting_time) {
            is_setting_time = 1;
            set_time_state = SET_HOUR_TENS;
            show_digit = 1;
            blink_counter = 0;
        } else {
            is_setting_time = 0;
            set_time_state = SET_DONE;
        }
        tempValue = 255;
        return;
    }

    if (!is_setting_time || tempValue > 9) return;  // 只处理0-9的按键输入

    switch (set_time_state) {
        case SET_HOUR_TENS:
            if (tempValue > 2) tempValue = 2;  // 限制小时十位最大为2
            stTime.mHour = tempValue * 10;
            set_time_state = SET_HOUR_ONES;
            break;
            
        case SET_HOUR_ONES:
            if (stTime.mHour == 20 && tempValue > 3) tempValue = 3;  // 如果十位是2，个位最大为3
            stTime.mHour = (stTime.mHour / 10) * 10 + tempValue;
            set_time_state = SET_MIN_TENS;
            break;
            
        case SET_MIN_TENS:
            if (tempValue > 5) tempValue = 5;  // 限制分钟十位最大为5
            stTime.mMinute = tempValue * 10;
            set_time_state = SET_MIN_ONES;
            break;
            
        case SET_MIN_ONES:
            stTime.mMinute = (stTime.mMinute / 10) * 10 + tempValue;
            set_time_state = SET_SEC_TENS;
            break;
            
        case SET_SEC_TENS:
            if (tempValue > 5) tempValue = 5;  // 限制秒十位最大为5
            stTime.mSecond = tempValue * 10;
            set_time_state = SET_SEC_ONES;
            break;
            
        case SET_SEC_ONES:
            stTime.mSecond = (stTime.mSecond / 10) * 10 + tempValue;
            is_setting_time = 0;
            set_time_state = SET_DONE;
            break;

        case SET_DONE:
            break;
        }
}
/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
extern TIM_HandleTypeDef htim3;
/* USER CODE BEGIN EV */
extern stSysTickTimer sSysTickTimer;
extern structTime stTime;
extern void Display(void);
extern uint16_t mPos;
extern uint16_t mNum;
extern uint8_t tempValue;
extern uint8_t KeyValue;

/* USER CODE END EV */

/******************************************************************************/
/*           Cortex-M4 Processor Interruption and Exception Handlers          */
/******************************************************************************/
/**
  * @brief This function handles Non maskable interrupt.
  */
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */
   while (1)
  {
  }
  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
  * @brief This function handles Hard fault interrupt.
  */
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */

  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Memory management fault.
  */
void MemManage_Handler(void)
{
  /* USER CODE BEGIN MemoryManagement_IRQn 0 */

  /* USER CODE END MemoryManagement_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_MemoryManagement_IRQn 0 */
    /* USER CODE END W1_MemoryManagement_IRQn 0 */
  }
}

/**
  * @brief This function handles Prefetch fault, memory access fault.
  */
void BusFault_Handler(void)
{
  /* USER CODE BEGIN BusFault_IRQn 0 */

  /* USER CODE END BusFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_BusFault_IRQn 0 */
    /* USER CODE END W1_BusFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Undefined instruction or illegal state.
  */
void UsageFault_Handler(void)
{
  /* USER CODE BEGIN UsageFault_IRQn 0 */

  /* USER CODE END UsageFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_UsageFault_IRQn 0 */
    /* USER CODE END W1_UsageFault_IRQn 0 */
  }
}

/**
  * @brief This function handles System service call via SWI instruction.
  */
void SVC_Handler(void)
{
  /* USER CODE BEGIN SVCall_IRQn 0 */

  /* USER CODE END SVCall_IRQn 0 */
  /* USER CODE BEGIN SVCall_IRQn 1 */

  /* USER CODE END SVCall_IRQn 1 */
}

/**
  * @brief This function handles Debug monitor.
  */
void DebugMon_Handler(void)
{
  /* USER CODE BEGIN DebugMonitor_IRQn 0 */

  /* USER CODE END DebugMonitor_IRQn 0 */
  /* USER CODE BEGIN DebugMonitor_IRQn 1 */

  /* USER CODE END DebugMonitor_IRQn 1 */
}

/**
  * @brief This function handles Pendable request for system service.
  */
void PendSV_Handler(void)
{
  /* USER CODE BEGIN PendSV_IRQn 0 */

  /* USER CODE END PendSV_IRQn 0 */
  /* USER CODE BEGIN PendSV_IRQn 1 */

  /* USER CODE END PendSV_IRQn 1 */
}

/**
  * @brief This function handles System tick timer.
  */
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */

  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  /* USER CODE BEGIN SysTick_IRQn 1 */
  HanziDiplay();
  if (++sSysTickTimer.mMilSecCount >= 10) {
    sSysTickTimer.mMilSecCount = 0;
    sSysTickTimer.bTenMilSecOk = 1;
    KeyValue = MatrixKeyScan();
    if (KeyValue != NO_KEY) {
      for (int i = 0; i < 16; i++) {
        if (KeyValue == KeyTable[i]) {
          tempValue = i;
          break;
        }
      }
      process_time_setting();
      // DispToBuff(tempValue);
    }
    if (++sSysTickTimer.mHundredMilSecCount >= 10) {
      sSysTickTimer.mHundredMilSecCount = 0;
      sSysTickTimer.bHundredMilSecOk = 1;
      if (is_setting_time) {
        show_digit = !show_digit;
      }
      if (++sSysTickTimer.mTimeCount >= 10) {
        sSysTickTimer.mTimeCount = 0;
        sSysTickTimer.bTimeOk = 1;
        if(++mNum>=19)
          mNum=15;	
      }
    }
  }
  /* USER CODE END SysTick_IRQn 1 */
}

/******************************************************************************/
/* STM32G4xx Peripheral Interrupt Handlers                                    */
/* Add here the Interrupt Handlers for the used peripherals.                  */
/* For the available peripheral interrupt handler names,                      */
/* please refer to the startup file (startup_stm32g4xx.s).                    */
/******************************************************************************/

/**
  * @brief This function handles TIM3 global interrupt.
  */
void TIM3_IRQHandler(void)
{
  /* USER CODE BEGIN TIM3_IRQn 0 */

  /* USER CODE END TIM3_IRQn 0 */
  HAL_TIM_IRQHandler(&htim3);
  /* USER CODE BEGIN TIM3_IRQn 1 */
  Display();
  if (++stTime.mTenMilCount >= 10) {
    stTime.mTenMilCount = 0;
    stTime.bTenMilIsOk = 1;
    if (++stTime.mTimeCount >= 100) {
      stTime.mTimeCount = 0;
      stTime.bSecondIsOk = 1;
      TimeToBuff(&stTime);
      if (++stTime.mSecond >= 60) {
        stTime.mSecond = 0;
        if (++stTime.mMinute >= 60) {
          stTime.mMinute = 0;
          if (++stTime.mHour >= 24) {
            stTime.mHour = 0;
          }
        }
      }
    }
  }
  /* USER CODE END TIM3_IRQn 1 */
}

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */
